using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Chop.Game.Messages.IDs;
using Chop.Rooms;

namespace Chop.Game.Messages.Incoming.navigator
{
    class MyRoomsSearchMessageComposer: IMessageHandler
    {
        public void Handle(GameClient client, RequestParser parser)
        {
            List<NavigatorRoom> rooms = Core.NavigatorManager.GetUsersRooms(client.mHabbo.mName);

            ResponseBuilder message = new ResponseBuilder(OutgoingMessages.GuestRoomSearchResultEvent); // 451
            message.AppendInt32(5); // searchType
            message.AppendString(""); // searchParam

            message.AppendInt32(rooms.Count); // room count
            foreach (NavigatorRoom room in rooms)
            {
                room.AddToPacket(message);
            }

            message.AppendBoolean(false); // is offical rooms
            client.SendMessage(message);
        }
    }
}