﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;
using Chop.Database;
using System.Text.RegularExpressions;

namespace Chop.Game.Misc
{
    public class BobbaFilter
    {
        public List<string> mWords;
        public string mReplacementWord;

        public BobbaFilter()
        {
            mWords = new List<string>();
        }

        public void Init()
        {
            if (!Core.Config.GetBoolean("game.bobbafilter.enabled"))
                return;

            mReplacementWord = Core.Config.GetString("game.bobbafilter.replacement");
            mWords.Clear();

            DataTable table;
            using (DatabaseClient dbClient = Core.DatabaseManager.GetClient())
                table = dbClient.ReadDataTable("SELECT * FROM bobbafilter");

            foreach (DataRow row in table.Rows)
                mWords.Add(row["word"].ToString());
        }
        public string FilterText(string s)
        {
            if (!Core.Config.GetBoolean("game.bobbafilter.enabled"))
                return s;

            foreach (string word in mWords)
                s = Regex.Replace(s, word, mReplacementWord, RegexOptions.IgnoreCase);

            return s;
        }
        public bool ContainsBobba(string s)
        {
            if (!Core.Config.GetBoolean("game.bobbafilter.enabled"))
                return false;

            foreach (string word in mWords)
                if (s.ToLower().Contains(word.ToLower()))
                    return true;
            return false;
        }
    }
}
